#include <Canvas\Canvas3D.mqh>
#include <Canvas\DX\DXBox.mqh>
#define   TEXTURE_CHECKER "::Examples/Math 3D Morpher/Textures/checker.bmp"
#resource "Examples/Math 3D Morpher/Textures/checker.bmp"
CCanvas3D C;
CDXBox B;

input int Size=500;
input int Width=100;
input int Height=50;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   C.CreateBitmapLabel("Box",100,100,Size,Size);
   B.Create(C.DXDispatcher(),C.InputScene(),DXVector3(-1,-1,-1),DXVector3(1,1,1));
   C.ProjectionMatrixSet((float)M_PI_4,1,0.1f,100.0f);
   C.ViewPositionSet(DXVector3(4,2,3));
   C.ViewUpDirectionSet(DXVector3(0,1,0));
   B.TextureSet(C.DXDispatcher(),TEXTURE_CHECKER);
   C.ObjectAdd(&B);
   C.Render(DX_CLEAR_COLOR|DX_CLEAR_DEPTH,ColorToARGB(clrGreen));
   C.Update();
   
   int w=Width, h=Height, s=Size;
   int x=s+100,y=100; NewObj("AmbientColorSet","1","1","1","1",x,y,w,h);
   y+=h; NewObj("LightDirectionSet","1","0","0","",x,y,w,h);
   y+=h; NewObj("LightColorSet","0","0","0","0",x,y,w,h);
   y+=h; NewObj("ProjectionMatrixSet","45","1","0.1","100",x,y,w,h);
   y+=h; NewObj("ViewPositionSet","4","2","3","",x,y,w,h);
   y+=h; NewObj("ViewRotationSet","0","0","0","",x,y,w,h);
   y+=h; NewObj("ViewTargetSet","0","0","0","",x,y,w,h);
   y+=h; NewObj("ViewUpDirectionSet","0","1","0","",x,y,w,h);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   B.Shutdown();
   ObjectsDeleteAll(0,"Box");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---
   if(id!=CHARTEVENT_OBJECT_ENDEDIT) return;
   string pref="Box ";
   string name=StringSubstr(sparam,StringLen(pref),StringLen(sparam)-StringLen(pref)-2);
   string str[4]={" R"," G"," B"," A"};
   float txt[4]={0};
   for(int i=0;i<4;i++) {txt[i]=(float)StringToDouble(ObjectGetString(0,pref+name+str[i],OBJPROP_TEXT));}
   if(name=="AmbientColorSet")     {C.AmbientColorSet    (DXColor(txt[0],txt[1],txt[2],txt[3]));}
   if(name=="LightColorSet")       {C.LightColorSet      (DXColor(txt[0],txt[1],txt[2],txt[3]));}
   if(name=="LightDirectionSet")   {C.LightDirectionSet  (DXVector3(txt[0],txt[1],txt[2]));}
   if(name=="ViewPositionSet")     {C.ViewPositionSet    (DXVector3(txt[0],txt[1],txt[2]));}
   if(name=="ViewRotationSet")     {C.ViewRotationSet    (DXVector3(txt[0],txt[1],txt[2]));}
   if(name=="ViewTargetSet")       {C.ViewTargetSet      (DXVector3(txt[0],txt[1],txt[2]));}
   if(name=="ViewUpDirectionSet")  {C.ViewUpDirectionSet (DXVector3(txt[0],txt[1],txt[2]));}
   if(name=="ProjectionMatrixSet") {C.ProjectionMatrixSet(float(txt[0]*M_PI/180.),txt[1],txt[2],txt[3]);}
   C.Render(DX_CLEAR_COLOR|DX_CLEAR_DEPTH,ColorToARGB(clrGreen));
   C.Update();
  }
//+------------------------------------------------------------------+
  
void NewObj(string name, string r, string g, string b, string a, int x, int y, int w=100, int h=50)
  {string str[4]={" R"," G"," B"," A"};
   string txt[4]; txt[0]=r; txt[1]=g; txt[2]=b; txt[3]=a;
   string pref="Box ";
   for(int i=0;i<4;i++,x+=w)
     {ObjectCreate(0,pref+name+str[i],OBJ_EDIT,0,0,0);
      ObjectSetString(0,pref+name+str[i],OBJPROP_TEXT,txt[i]);
      ObjectSetInteger(0,pref+name+str[i],OBJPROP_ALIGN,ALIGN_CENTER);
      ObjectSetInteger(0,pref+name+str[i],OBJPROP_XDISTANCE,x);
      ObjectSetInteger(0,pref+name+str[i],OBJPROP_YDISTANCE,y);
      ObjectSetInteger(0,pref+name+str[i],OBJPROP_XSIZE,w);
      ObjectSetInteger(0,pref+name+str[i],OBJPROP_YSIZE,h);
     }
   ObjectCreate(0,pref+name,OBJ_LABEL,0,0,0);
   ObjectSetString(0,pref+name,OBJPROP_TEXT," "+name);
   ObjectSetInteger(0,pref+name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(0,pref+name,OBJPROP_YDISTANCE,y);
  }